/* SOUND BASED SIMPLE DEMO */
/* Author: Ambika Yadav*/
/* Supervisor: George Legrady*/
/* MAT 259 : Winter 2017 */

import ddf.minim.*;
 
Minim minim;
boolean playing = false ;
AudioPlayer player1, player2, player3, player4, player5;
boolean[] play ;
String[] mp3filename = {"1.mp3","2.mp3","3.mp3","4.mp3","5.mp3"};
color[] rectangles = {#581845,#300C3F,#c70039,#FF5733,#FFc305};
PFont font ;
void setup() { 
 
  size(700, 300);
  
  font = createFont("Helvetica.ttf",32);
  minim = new Minim(this);
  play = new boolean[mp3filename.length];
  for ( int i = 0 ; i <mp3filename.length ;i++)
  {
    play[i]=false;
  }
  
  player1 = minim.loadFile(mp3filename[0], 512);
  player2 = minim.loadFile(mp3filename[1], 512);
  player3 = minim.loadFile(mp3filename[2], 512);
  player4 = minim.loadFile(mp3filename[3], 512);
  player5 = minim.loadFile(mp3filename[4], 512);
}
 
void draw() {
  background(250,250,250);
  int x_start = 130 ; 
  int y_start = 100; 
  int x_width = 60;
  int y_width = 90;
  int db_cells = 30;
  int[] x_s = new int[mp3filename.length];
  
  for ( int a = 0 ; a<mp3filename.length ;a++)
  {
    x_s[a] = x_start + a*x_width + a*db_cells;
    noStroke();
    fill(rectangles[a],100);
    rect(x_s[a],y_start,x_width,y_width);
  }
  
  if (mouseX>x_s[0] && mouseX<x_s[0]+x_width && mouseY>y_start && mouseY<y_start+y_width)
  {
    play[0] = true;
    play[1] = false;
    play[2] = false;
    play[3] = false;
    play[4] = false;
    fill(rectangles[0],255);
    rect(x_s[0],y_start,x_width,y_width);
  }
  else if (mouseX>x_s[1] && mouseX<x_s[1]+x_width && mouseY>y_start && mouseY<y_start+y_width)
  {
    play[0] = false;
    play[1] = true;
    play[2] = false;
    play[3] = false;
    play[4] = false;
    fill(rectangles[1],255);
    rect(x_s[1],y_start,x_width,y_width);
  }
  else if (mouseX>x_s[2] && mouseX<x_s[2]+x_width && mouseY>y_start && mouseY<y_start+y_width)
  {
    play[0] = false;
    play[1] = false;
    play[2] = true;
    play[3] = false;
    play[4] = false;
    fill(rectangles[2],255);
    rect(x_s[2],y_start,x_width,y_width);
  }
  else if (mouseX>x_s[3] && mouseX<x_s[3]+x_width && mouseY>y_start && mouseY<y_start+y_width)
  {
    play[0] = false;
    play[1] = false;
    play[2] = false;
    play[3] = true;
    play[4] = false;
    fill(rectangles[3],255);
    rect(x_s[3],y_start,x_width,y_width);
  }
 else if (mouseX>x_s[4] && mouseX<x_s[4]+x_width && mouseY>y_start && mouseY<y_start+y_width)
  {
    play[0] = false;
    play[1] = false;
    play[2] = false;
    play[3] = false;
    play[4] = true;
    fill(rectangles[4],255);
    rect(x_s[4],y_start,x_width,y_width);
  }
 else 
  {
    play[0] = false;
    play[1] = false;
    play[2] = false;
    play[3] = false;
    play[4] = false;
  }
  
  if (play[0] ==true  && playing == false) 
  {
    player1.play();
    playing = true;
  }
  else  if (play[1] ==true  && playing == false) 
  {
    player2.play();
    playing = true;
  }
   else  if (play[2] ==true  && playing == false) 
  {
    player3.play();
    playing = true;
  }
   else  if (play[3] ==true  && playing == false) 
  {
    player4.play();
    playing = true;
  }
   else  if (play[4] ==true  && playing == false) 
  {
    player5.play();
    playing = true;
  }
  else if (play[0] == false && play[0] == false && play[0] == false && play[0] == false && play[0] == false && playing == true) 
  {
    player1.pause();
    player2.pause();
    player3.pause();
    player4.pause();
    player5.pause();
    playing = false;
  }
  
  textFont(font);
  textSize(20);
  fill(0,0,0,255);
  textAlign(CENTER,CENTER);
  text("SIMPLE AUDIO DEMO",width/2,30);
  textSize(10);
  text("Built in Processing 3.2.3",width/2,47);
  textSize(15);
  text("| Hover over boxes to hear different audios |",width/2,height-20);
}